%ifarch alpha ia64 ppc64 s390x sparc64 x86_64
%global flavor gcc64pthr
%global enable64 yes
%else
%global flavor gcc32pthr
%global enable64 no
%endif

%global debug_package %{nil}

%{!?perl_vendorlib: %global perl_vendorlib %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)}

Name:		globus-core
%global _name %(tr - _ <<< %{name})
Version:	5.15
Release:	5%{?dist}
Summary:	Globus Toolkit - Globus Core

Group:		Development/Tools
License:	ASL 2.0
URL:		http://www.globus.org/
#		Source is extracted from the globus toolkit installer:
#		wget -N http://www-unix.globus.org/ftppub/gt4/4.2.1/installers/src/gt4.2.1-all-source-installer.tar.bz2
#		tar -jxf gt4.2.1-all-source-installer.tar.bz2
#		mv gt4.2.1-all-source-installer/source-trees/core/source globus_core-5.15
#		tar -zcf globus_core-5.15.tar.gz globus_core-5.15
Source:		%{_name}-%{version}.tar.gz
#		GPT metadata to pkg-config file converter
Source1:	globus-gpt2pkg-config
#		Globus RPM specfile creator script
Source2:	globus-spec-creator
#		Make file locations configurable:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6451
Patch0:		%{name}-conf.patch
#		Environment variable elimination patch:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6452
Patch1:		%{name}-usr.patch
#		Missing functions in configure check:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6453
Patch2:		%{name}-func.patch
#		Detect IOV_MAX correctly (requires _GNU_SOURCE):
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6454
Patch3:		%{name}-gnusource.patch
#		Make GPT_AGE_VERSION available to autotools:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6455
Patch4:		%{name}-age-version.patch
#		Missing shebang:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6456
Patch5:		%{name}-bootstrap-shebang.patch
#		Make configure --help look nice:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6457
Patch6:		%{name}-helpstring.patch
#		Fix doxygen documentation installation instructions:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6458
Patch7:		%{name}-doxygen.patch
#		Make it work with older and newer automake versions:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6565
Patch8:		%{name}-compat.patch
#		Avoid race condition when renaming the libtool file:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6575
Patch9:		%{name}-libtool.patch
#		Properly propagate $AR and $RANLIB:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6739
Patch10:	%{name}-ar-ranlib.patch
#		Fixes for mingw compilation:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6742
Patch11:	%{name}-mingw.patch
#		Fix build configuration for s390x and kfreebsd:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6754
Patch12:	%{name}-platforms.patch
#		Adapt dependency script to Fedora's documentation location:
#		Not relevant for upstream - not submitted to globus bugzilla
Patch13:	%{name}-fedora.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%{name}-devel < 5.15-0.5
Requires:	pkgconfig
Requires:	perl(XML::DOM)
Requires:	perl(XML::Parser)
BuildRequires:	grid-packaging-tools
BuildRequires:	perl(XML::DOM)
BuildRequires:	perl(XML::Parser)

%description
The Globus Toolkit is an open source software toolkit used for building Grid
systems and applications. It is being developed by the Globus Alliance and
many others all over the world. A growing number of projects and companies are
using the Globus Toolkit to unlock the potential of grids for their cause.

The %{name} package contains:
Globus Core

%prep
%setup -q -n %{_name}-%{version}
%patch0 -p1 -b .conf
%patch1 -p1 -b .usr
%patch2 -p1 -b .func
%patch3 -p1 -b .gnusource
%patch4 -p1 -b .age
%patch5 -p1 -b .shebang
%patch6 -p1 -b .help
%patch7 -p1 -b .doxygen
%patch8 -p1 -b .compat
%patch9 -p1 -b .libtool
%patch10 -p1 -b .ranlib
%patch11 -p1 -b .mingw
%patch12 -p1 -b .platform
%patch13 -p1 -b .fedora

# custom perl requires that removes dependency on gpt perl modules
cat << EOF > %{name}-req
#!/bin/sh
%{__perl_requires} $* |\
sed -e '/perl(Grid::GPT::.*)/d'
EOF
%global __perl_requires %{_builddir}/%{_name}-%{version}/%{name}-req
chmod +x %{__perl_requires}

%build
rm -rf autom4te.cache
./bootstrap

%configure --includedir='${prefix}/include/globus' \
	   --libexecdir='${datadir}/globus' \
	   --with-threads=pthreads --with-thread-library=%{_libdir} \
	   --with-flavor=%{flavor} \
	   --enable-64bit=%{enable64} \
	   --with-setupdir='${datadir}/globus/setup' \
	   --with-testdir='${datadir}/globus/test/${PACKAGE}' \
	   --with-flavorincludedir='${libdir}/globus/include' \
	   --with-perlmoduledir=%{perl_vendorlib} \
	   --with-doxygendir='${datadir}/globus/doxygen' \
	   --with-newgpt

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# These scripts are intended to be sourced, not executed
chmod 644 $RPM_BUILD_ROOT%{_datadir}/globus/globus-build-env-*.sh

GLOBUSPACKAGEDIR=$RPM_BUILD_ROOT%{_datadir}/globus/packages

# Add -Wl,--as-needed to the libtool script if supported
%if %{?fedora}%{!?fedora:0} >= 2
sed 's! -shared ! \\\${wl}--as-needed&!g' \
  -i $RPM_BUILD_ROOT%{_sbindir}/libtool-%{flavor}
%endif
%if %{?rhel}%{!?rhel:0} >= 4
sed 's! -shared ! \\\${wl}--as-needed&!g' \
  -i $RPM_BUILD_ROOT%{_sbindir}/libtool-%{flavor}
%endif

# Install the GPT metadata to pkg-config file converter
install %SOURCE1 $RPM_BUILD_ROOT%{_datadir}/globus/globus-gpt2pkg-config

# Install the Globus RPM specfile creator script
mkdir -p $RPM_BUILD_ROOT%{_bindir}
install %SOURCE2 $RPM_BUILD_ROOT%{_bindir}/globus-spec-creator
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
pod2man %SOURCE2 > $RPM_BUILD_ROOT%{_mandir}/man1/globus-spec-creator.1

# Generate pkg-config file from GPT metadata
mkdir -p $RPM_BUILD_ROOT%{_libdir}/pkgconfig
$RPM_BUILD_ROOT%{_datadir}/globus/globus-gpt2pkg-config \
  pkgdata/pkg_data_%{flavor}_dev.gpt > \
  $RPM_BUILD_ROOT%{_libdir}/pkgconfig/%{name}.pc

# Remove license file installed directly in the buildroot
rm -f $RPM_BUILD_ROOT/GLOBUS_LICENSE
sed /GLOBUS_LICENSE/d -i $GLOBUSPACKAGEDIR/%{_name}/noflavor_data.filelist

# Install license file
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -m 644 -p GLOBUS_LICENSE $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# Generate package filelists
cat $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_pgm.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_rtl.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_dev.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/noflavor_data.filelist \
  | sed s!^!%{_prefix}! > package.filelist

%clean
rm -rf $RPM_BUILD_ROOT

%files -f package.filelist
%defattr(-,root,root,-)
%dir %{_datadir}/globus
%dir %{_datadir}/globus/aclocal
%dir %{_datadir}/globus/doxygen
%dir %{_datadir}/globus/flavors
%dir %{_datadir}/globus/packages
%dir %{_datadir}/globus/packages/%{_name}
%dir %{_libdir}/globus
%dir %{_libdir}/globus/include
%{_libdir}/pkgconfig/%{name}.pc
%{_datadir}/globus/globus-gpt2pkg-config
%{_bindir}/globus-spec-creator
%doc %{_mandir}/man1/globus-spec-creator.1*
%dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/GLOBUS_LICENSE

%changelog
* Tue Jun 02 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.15-5
- Update to official Fedora Globus packaging guidelines
- Fix build configuration for s390x and kfreebsd
- Make globus-core work with automake 1.11

* Mon Apr 27 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.15-4
- Install the globus-spec-creator script
- Add -Wl,--as-needed to the libtool script

* Tue Apr 21 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.15-3
- Update after clarification of packaging guidelines

* Wed Apr 15 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.15-2
- Make comment about source retrieval more explicit

* Fri Mar 20 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.15-1
- Change defines to globals

* Sun Mar 15 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.15-0.5
- Merge devel with main

* Thu Feb 26 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.15-0.4
- Add s390x to the list of 64 bit platforms

* Mon Dec 29 2008 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.15-0.3
- Adapt to updated GPT package

* Sun Oct 12 2008 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.15-0.2
- Update to Globus Toolkit 4.2.1

* Mon Jul 14 2008 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.14-0.1
- Autogenerated
